# Change Log

## v3.3.1

[compare changes](https://github.com/Jannchie/anichart.js/compare/v3.3.0...v3.3.1)

### 🩹 Fixes

- **bar:** X axis domain ([d5920c5](https://github.com/Jannchie/anichart.js/commit/d5920c5))

### ❤️ Contributors

- Jianqi Pan ([@Jannchie](http://github.com/Jannchie))

## ver 3.2.0 [2022-10-07]

- In the Stage component, use the async and await syntax.

**Base Chart**

- Data optimization has been introduced and will now remove redundant data entries.

**Map Chart**

- Fixed the issue that map chart default fill does not work.
- Adds the current value as the second parameter to the visual map callback function.
- Allows the camera to follow the top entry.

**Bar Chart**

- Enables the option of visualRange is `history`.

## ver 3.1.0 [2022-10-06]

- Optimized rendering logic and component composition.
- Added the component's key property to identify the component.
- The resource is now contained by stage.

## ver 3.0.2 [2022-08-15]

**Chore**

- Clean the code.
- Use pnpm to manage dependencies.

## ver 3.0.1 [2022-06-19]

**Fixed**

- Fixed a dependency error.

## ver 3.0.0 [2022-06-18]

In this brand new version, I have simplified the project. Specifically, going forward the project will focus on visual chart generation and remove the rendering to video part.

I found a new library called [Remotion](https://www.remotion.dev/), which is dedicated to rendering browser elements and animations into videos. It is recommended that you use this library to render the charts generated by anichart.

I have also created a plugin to easily use anichart for remotion for data visualization creation.

In addition, I have used Vitepress to create a new document that includes a manual of options for charts, and a tutorial on using anichart to create charts and render videos.

**What's Changed**

- Remove all render modules.
- Remove dependencies that are no longer needed.
- Optimized package size.
- Fixed the map without data background. A striped background is now displayed by default when there is no data.
- Added a new Canvas Helper to generate patterns from images.

**Docs**

- New documentation online
- Added options manual
- Added a tutorial on using anichart in remotion.
- Updated the readme for the project.

## ver 2.5.0 [2022-05-05]

**New Features**

- Added the option to control whether to display x, y axies or not.

**Fixed**

- Fixed an issue where the label was displayed incorrectly in the line chart.

## ver 2.4.5 [2022-05-05]

**Fixed**

- Fixed an issue that limited the number of entries incorrectly.

## ver 2.4.4 [2021-09-24]

**Fixed**

- Fixed the issue that the initial value of the bar chart is NaN will be displayed.

## ver 2.4.3 [2021-09-15]

**Fixed**

- Fixed the issue of incorrect initialization of properties in the parameterless part of chart construction.
- Fixed the issue that the bar chart timestamp option was overwritten incorrectly.

## ver 2.4.2 [2021-08-14]

**Fixed**

- Fixed an issue that caused incorrect calculation of y-axis coordinates for multiple bar chart.

**Beautified**

- Added a configuration item clipBar that specifies whether the information on the bar chart can go beyond the bar.

## ver 2.4.1 [2021-08-13]

**New Features**

- Optimized the efficiency as well as the performance of the interpolation algorithm. Optimized the cascading order of bar bars.

**Fixed**

- Removed the optimization item to remove duplicate values. This optimization item would cause inconsistent chart performance.

**Beautified**

- Optimized the interpolation position so that the transition effect is preserved when using non-NaN default values.
- Optimized the cascading order of the bar chart, now the rising entries are ahead of the falling ones.

## ver 2.4.0 [2021-08-12]

**New Features**

- Add controllers, which can display and adjust playback progress。
- Optimized the convolution calculation for histograms. The convolution calculation is used to calculate the y-axis coordinates of the entries.

**Fixed**

- Fixed multiple issues that could cause components to be duplicated with Setup。

## ver 2.3.1 [2021-08-09]

**Fixed**

- Fixed the problem of having to bring in the canvas library as a dependency
- Fixed the default bar chart reporting undefined when there are no options

## ver 2.3.0 [2021-08-07]

Due to an update to the browser security policy, the original video export module is not available. The module has been updated, but callers who use New Features for exporting video still need to modify part of the source code.

[Read here](https://developer.chrome.com/blog/enabling-shared-array-buffer/#origin-trial) for more information。

**New Features**

- Added the option to customize the domain of the horizontal axis of the bar chart.

**Fixed**

- Compatible browser security policy。
- Fixed the problem that barInfoFormat could not get the data of the bar chart.
- Fixed the logic of adding `NaN` automatically.

**Beautified**

- Changed pure white (#FFF) to purple (#569) in the default color scheme

## ver 2.2.1 [2021-07-15]

**Docs**

- Updated type description file.

## ver 2.2.0 [2021-07-15]

**New Features**

- Added support for non-standard dates.
- Added support for multi-column bar charts.
- Added the option to show bar chart ranking.
- Added the ability to customize the style of bar chart date labels

**Beautified**

- Beautified the alignment of the bar chart.
- Added fade out animation when the bar chart disappears

**Docs**

- Updated documentation
- Added English documentation

## ver 2.1.1 [2021-03-31]

**Chores**

- Removed some Console output.

## ver 2.1.0 [2021-03-31]

**New Features**

- Added support for Nodejs environments.

## ver 2.0.2

**New Features**

- Added option for axis ranges for bar charts
- Bar chart can now specify data values on outgoing and incoming
- Added support for map area name labels
- Added support for default background patterns for map plots

## ver 2.0.1

### Fixed

- Fixed compilation options, enabling the use of Typescript environments with type inference in online environments such as Code Sandbox.

## ver 2.0.0

**New Features**

- Fully refactored with Typescript.
- Added support for map charts.
- Added support for custom animators.
- Optimized project structure to separate renderer and data calculation.
- Added basic support for pie charts.
- Added basic support for regional maps and world maps.
- Optimized the calculation efficiency of the bar chart.
- Added progress bar component.
- Added zoom, fade in animation wrapper.
- Optimized the calculation efficiency of the line chart.

**Beautified**

- Optimized the calculation of the Label width of the bar chart.
